using System.Collections;
using Unity.Netcode;
using UnityEngine;

namespace MewMod.Hooks;

public class DisableFearSounds
{
    public static void DisableFearSoundsPatch(On.SoundManager.orig_SetFearAudio orig, SoundManager self)
    {
        /*
         *  this disables fear sounds by making sure they're off, and then not running the function that touches fear sounds.
         *  potentially breaks other mods? ( if it does, we could run the original function, and then disable the sounds immediately afterwards to be sure
         *  ( but would rather not do that unless absolutely necessary. )
         *  ( plus, honestly, any mod that touches the fear sounds is likely to just make things scarier, so this is probably OK. )
         */
        self.highAction1.volume = 0f;
        self.highAction1.Stop();
        self.highAction2.volume = 0f;
        self.highAction2.Stop();
        self.heartbeatSFX.volume = 0f;
        self.heartbeatSFX.Stop();
        self.lowAction.volume = 0f;
        self.lowAction.Stop();
    }
}