using System.Collections;
using Unity.Netcode;
using UnityEngine;

namespace MewMod.Hooks;

public class DisableMaskedJumpscare
{
    public static IEnumerator DisableJumpscarePatch(On.MaskedPlayerEnemy.orig_killAnimation orig, MaskedPlayerEnemy self)
    {
        /*
         *  this disables the masked man jumpscare, replacing it with Immediate Death ( less scary )
         */
        
        // skip through half the function, just do the dying part instead
        // TODO: make this just pause for 3s and like.... show a black screen instead?
        // gf immediately pointed out " but wait, one can get saved by killing the masked, this is not ideal "
        self.lastPlayerKilled = self.inSpecialAnimationWithPlayer;
        bool flag = self.inSpecialAnimationWithPlayer.transform.position.y < -80f;
        self.inSpecialAnimationWithPlayer.KillPlayer(Vector3.zero, spawnBody: false, CauseOfDeath.Strangulation, 4);
        self.inSpecialAnimationWithPlayer.snapToServerPosition = false;
        self.FinishKillAnimation(killedPlayer: true);
        if (self.IsServer)
        {
            self.playersKilled.Add((int)self.inSpecialAnimationWithPlayer.playerClientId);
            NetworkObjectReference netObjectRef = RoundManager.Instance.SpawnEnemyGameObject(self.GetGroundPosition(self.playerRay.origin), self.inSpecialAnimationWithPlayer.transform.eulerAngles.y, -1, self.enemyType);
            if (netObjectRef.TryGet(out var networkObject))
            {
                MaskedPlayerEnemy component = networkObject.GetComponent<MaskedPlayerEnemy>();
                component.SetSuit(self.inSpecialAnimationWithPlayer.currentSuitID);
                component.mimickingPlayer = self.inSpecialAnimationWithPlayer;
                component.SetEnemyOutside(!flag);
                self.inSpecialAnimationWithPlayer.redirectToEnemy = component;
                if (self.inSpecialAnimationWithPlayer.deadBody != null)
                {
                    self.inSpecialAnimationWithPlayer.deadBody.DeactivateBody(setActive: false);
                }
            }
            self.CreateMimicClientRpc(netObjectRef, flag, (int)self.inSpecialAnimationWithPlayer.playerClientId);
        }
        
        // Get the IEnumerator returned by the original method
        
        //IEnumerator origIEnumerator = orig(self);
        // Repeat until MoveNext of origIEnumerator is false
        //while (origIEnumerator.MoveNext())
        //{
        //    yield return origIEnumerator.Current;
        //} 
        
        // code here runs after the original method
        yield return null;
    }
}