using System.Collections;
using Unity.Netcode;
using UnityEngine;

namespace MewMod.Hooks;

public class DisableScaryAmbientSounds
{
    public static void DisableScaryAmbientSoundsPatch(On.SoundManager.orig_PlayAmbientSound orig, SoundManager self, bool syncedForAllPlayers = false, bool playInsanitySounds = false)
    {
        /*
         *  do nothing if playInsanitySounds is true ( *think theres a minor chance we error or crash the game if we just force insanitySounds to false )
         */
        if (playInsanitySounds == false) {
            orig(self, syncedForAllPlayers, playInsanitySounds);
        }
    }

    public static void DisableScaryAmbientSoundsRpcPatch(On.SoundManager.orig_PlayAmbienceClipClientRpc orig,
        SoundManager self, int soundType, int clipIndex, float soundVolume, bool playInsanitySounds)
    {
        /* uh oh! scary rpc stuff....
            about same as above, but we have to handle it properly to not Fuck Networking Up */
        NetworkManager networkManager = self.NetworkManager;
        if ((object)networkManager == null || !networkManager.IsListening)
        {
            return;
        }
        if (self.__rpc_exec_stage != NetworkBehaviour.__RpcExecStage.Client && (networkManager.IsServer || networkManager.IsHost))
        {
            ClientRpcParams clientRpcParams = default(ClientRpcParams);
            FastBufferWriter bufferWriter = self.__beginSendClientRpc(580761520u, clientRpcParams, RpcDelivery.Reliable);
            BytePacker.WriteValueBitPacked(bufferWriter, soundType);
            BytePacker.WriteValueBitPacked(bufferWriter, clipIndex);
            bufferWriter.WriteValueSafe(in soundVolume, default(FastBufferWriter.ForPrimitives));
            bufferWriter.WriteValueSafe(in playInsanitySounds, default(FastBufferWriter.ForPrimitives));
            self.__endSendClientRpc(ref bufferWriter, 580761520u, clientRpcParams, RpcDelivery.Reliable);
        }
        if (self.__rpc_exec_stage != NetworkBehaviour.__RpcExecStage.Client || (!networkManager.IsClient && !networkManager.IsHost))
        {
            return;
        }
        if (playInsanitySounds == false) {
            orig(self, soundType, clipIndex, soundVolume, playInsanitySounds);
        }
    }
}